/*
 * Copyright (c) 2003, Morpho Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 3. Neither the name of the Morpho Project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
package jp.morpho.webapp.servlet.http.impl;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletRequestWrapper;

import jp.morpho.io.UploadFile;
import jp.morpho.util.ConversionMap;
import jp.morpho.webapp.servlet.ActionRequestAttributeNames;
import jp.morpho.webapp.servlet.http.HttpActionRequest;

/**
 * <P>
 * HttpActionRequestImpl 饹ϡHTTP ֥åѤ׵󶡤 HttpActionRequest 󥿥եμǤ
 * Υ饹ϡåѡޤϥǥ졼Υѥ˴ŤƼƤޤ
 * ƥ᥽åɤϡåפ줿׵ᥪ֥ȤΥ᥽åɤǥեȤǸƤӽФޤ
 * </P>
 * <P>
 * HttpActionRequestImpl 饹ˤϡ׵뤿ɬפʥ䥹ơ뤿Υ᥽åɤ󶡤ޤ
 * </P>
 * @author Kenichi Fukuda
 */
public class HttpActionRequestImpl
	extends HttpServletRequestWrapper
	implements HttpActionRequest
{

	/**
	 * <P>
	 * ꤵ줿׵åפ HttpActionRequestImpl ۤޤ
	 * </P>
	 * @param request ֥åȤؤ׵
	 * @exception IllegalArgumentException ׵᤬ null ξ
	 */
	public HttpActionRequestImpl(HttpServletRequest request)
	{
		super(request);
	}

	/**
	 * <P>
	 * ׵륢ͤޤ
	 * </P>
	 * @return ׵륢
	 */
	public String getAction()
	{
		return (String)this.getAttribute(ActionRequestAttributeNames.action);
	}

	/**
	 * <P>
	 * ׵륢ͤꤷޤ
	 * </P>
	 * @param action ׵륢
	 */
	public void setAction(String action)
	{
		this.setAttribute(ActionRequestAttributeNames.action, action);
	}

	/**
	 * <P>
	 * ׵륹ơͤޤ
	 * </P>
	 * @return ׵륹ơ
	 */
	public String getStatus()
	{
		return (String)this.getAttribute(ActionRequestAttributeNames.status);
	}

	/**
	 * <P>
	 * ׵륹ơͤꤷޤ
	 * </P>
	 * @param status ׵륹ơ
	 */
	public void setStatus(String status)
	{
		this.setAttribute(ActionRequestAttributeNames.status, status);
	}

	/**
	 * <P>
	 * ׵ᤫǤѥ᡼ java.util.Map ֤ޤ
	 * ׵ѥ᡼Ȥϡ׵ȤȤɲþǤ
	 * HTTP ֥åȤξ硢ѥ᡼ϥ꡼ʸޤ POST 줿Υǡ˳ǼƤޤ
	 * </P>
	 * @return Ȥƥѥ᡼̾ޥåͤȤƥѥ᡼ͤǼ줿 java.util.Mapѥ᡼ޥåΥ String ѥ᡼ޥåͤϡѥ᡼ 1 ĤͤΤߤޤޤƤ String ʣͤĥѥ᡼ξ String 󷿡ѥ᡼ͤåץɤ줿եξ jp.morpho.io.UploadFile ޤ jp.morpho.io.UploadFile 
	 */
	public Map getParameterMap()
	{
		Map formValues = (Map)this.getAttribute(ActionRequestAttributeNames.form);
		if (formValues == null)
		{
			formValues = new ConversionMap();
		}
		return formValues;
	}

	/**
	 * <P>
	 * ׵˥ѥ᡼ꤷޤ
	 * </P>
	 * @param map ׵ѥ᡼
	 */
	public void setParameterMap(Map map)
	{
		this.setAttribute(ActionRequestAttributeNames.form, map);
	}

	/**
	 * <P>
	 * ׵˥ѥ᡼ΥޥåפˡΥѥ᡼Υޥåפ׵ᤫޤ<br>
	 * </P>
	 */
	public void removeParameterMap()
	{
		this.removeAttribute(ActionRequestAttributeNames.form);
	}

	/**
	 * <P>
	 * ׵ѥ᡼ͤ String Ȥ֤ޤ
	 * ѥ᡼¸ߤʤϡnull ֤ޤ
	 * ׵ѥ᡼ϡ׵ȤȤɲþǤ
	 * HTTP ֥åȤξ硢꡼ʸޤ POST 줿Υǡ˥ѥ᡼ǼƤޤ
	 * </P>
	 * <P>
	 * ѥ᡼ 1 ĤͤΤߤޤޤƤ뤳Ȥμ¤ʾˤΤߡΥ᥽åɤѤƤ
	 * ѥ᡼ʣͤޤޤƤǽϡgetParameterValues(java.lang.String) Ѥޤ
	 * </P>
	 * <P>
	 * ʣͤĥѥ᡼ФƤΥ᥽åɤѤ硢֤ͤϡgetParameterValues ֤κǽͤƱǤ
	 * </P>
	 * @param name ѥ᡼̾ꤹ String
	 * @return ѥ᡼ñͤɽ String
	 * @see javax.servlet.ServletRequest#getParameter(String)
	 */
	public String getParameter(String name)
	{
		ConversionMap formValues = ConversionMap.valueOf(this.getParameterMap());

		if (formValues.getObject(name) instanceof UploadFile)
		{
			return null;
		}
		if (formValues.isArray(name))
		{
			Object[] objs = (Object[])formValues.getObject(name);
			return objs[0].toString();
		}
		return formValues.getString(name);
	}

}
